#include <phigs.h>			/* get HP-PHIGS definitions for C */
#include <stdio.h>			/* get standard I/O definitions */
#include <math.h>			/* link with library "-lm" */
#define	 deg	*3.14159265358979/180.	/* convert degrees to radians */

main()					/* file "Rotate.c" */
{
    Pint	WorkstnID = 1;		/* workstation identifier */
    Pint	ConnID;			/* connection identifier */
    Pint	WorkstnType = POIDDX;	/* out/in, direct, dbl bfr, Xwindow */
    Pint	TheStructure = 1;	/* structure ID (chosen by user) */
    int		Angle;			/* current rotation angle */
    Pvec	UpVector;		/* character up vector */
    static Ptext_align	LeftHalf =	/* alignment for the left labels */
		{PHOR_LEFT, PVERT_HALF};
    Ppoint	Loc;			/* text location */
    char	String[20];		/* string holder */

    popen_phigs((char *) stderr, 0);	/* errors go to "stderr" */
    pescape_u4("/dev/screen/phigs_window", &ConnID);
    popen_ws(WorkstnID, (void *) ConnID, WorkstnType);
    popen_struct(TheStructure);
    pset_char_ht(0.035);
    pset_text_align(&LeftHalf);
    Loc.x = Loc.y = 0.5;
    for (Angle = 0; Angle <= 345; Angle += 15) {
	sprintf(String, "-----Angle=%d", Angle);
	UpVector.delta_x = cos(Angle deg);
	UpVector.delta_y = sin(Angle deg);
	pset_char_up_vec(&UpVector);
	ptext(&Loc, String);
    }
    pclose_struct();
    ppost_struct(WorkstnID, TheStructure, 1.0);
    pupd_ws(WorkstnID, PFLAG_PERFORM);	/* (regeneration flag) */
    pclose_ws(WorkstnID);
    pclose_phigs();
}
